package com.ruoyi.project.business.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.ruoyi.project.business.domain.TpParabar;
import com.ruoyi.project.business.domain.vo.parabar.CommonPara;
import com.ruoyi.project.business.domain.vo.parabar.CommonSelectItem;
import com.ruoyi.project.business.domain.vo.parabar.ElParabarVO;
import com.ruoyi.project.business.domain.vo.parabar.ParaForGetCommonPara;
import com.ruoyi.project.business.domain.vo.parabar.ParaModelRelatedVO;
import com.ruoyi.project.business.domain.vo.parabar.RelatedModelVO;
import java.util.List;
import org.apache.ibatis.annotations.Param;

/**
 * 参数包Mapper接口
 *
 * @author ruoyi
 * @date 2024-04-28
 */
public interface TpParabarMapper extends BaseMapper<TpParabar> {

    /**
     * 查询参数包
     *
     * @param id 参数包主键
     * @return 参数包
     */
    public TpParabar selectTpParabarById(Long id);

    /**
     * 查询参数包列表
     *
     * @param tpParabar 参数包
     * @return 参数包集合
     */
    public List<TpParabar> selectTpParabarList(TpParabar tpParabar);

    /**
     * 获取关联梯型
     *
     * @return 区域梯型集合
     */
    public List<RelatedModelVO> getRelatedModelList(TpParabar tpParabar);

    /**
     * 获取关联梯形的共同参数
     */
    public List<CommonPara> getCommonParaList(ParaForGetCommonPara para);


    /**
     * 获取关联梯形的共同参数以及共同选项
     */
    public List<CommonSelectItem> getCommonParaAndItemList(ParaForGetCommonPara para);

    /**
     * 新增参数包
     *
     * @param tpParabar 参数包
     * @return 结果
     */
    public int insertTpParabar(TpParabar tpParabar);

    /**
     * 修改参数包
     *
     * @param tpParabar 参数包
     * @return 结果
     */
    public int updateTpParabar(TpParabar tpParabar);

    /**
     * 删除参数包
     *
     * @param id 参数包主键
     * @return 结果
     */
    public int deleteTpParabarById(Long id);

    /**
     * 批量删除参数包
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTpParabarByIds(Long[] ids);

    public List<ParaModelRelatedVO> selectParaModelRelatedList(ParaModelRelatedVO paraModelRelatedVO);

    List<ElParabarVO> getParabarConfigByElevatorModelId(@Param("id") Long id);
}
